petsc-3.4.2 2013-07-02

# MatMatMult

Performs Matrix-Matrix Multiplication C=A*B.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatMatMult(Mat A,Mat B,MatReuse scall,PetscReal fill,Mat *C)

Neighbor-wise Collective on Mat

### Input Parameters

| A | - the left matrix
| B | - the right matrix
| scall | - either MAT_INITIAL_MATRIX or MAT_REUSE_MATRIX
| fill | - expected fill as ratio of nnz(C)/(nnz(A) + nnz(B)), use PETSC_DEFAULT if you do not have a good estimate if the result is a dense matrix this is irrelevent

### Output Parameters

C -the product matrix

### Notes

Unless scall is MAT_REUSE_MATRIX C will be created.

MAT_REUSE_MATRIX can only be used if the matrices A and B have the same nonzero pattern as in the previous call

To determine the correct fill value, run with -info and search for the string "Fill ratio" to see the value actually needed.

If you have many matrices with the same non-zero structure to multiply, you should either

      1) use MAT_REUSE_MATRIX in all calls but the first or

      2) call MatMatMultSymbolic() once and then MatMatMultNumeric() for each product needed

### See Also

MatMatMultSymbolic(), MatMatMultNumeric(), MatTransposeMatMult(), MatMatTransposeMult(), MatPtAP()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/ksp/examples/tutorials/ex39.c.html
src/ksp/ksp/examples/tutorials/ex40.c.html
src/snes/examples/tutorials/ex70.c.html